searchData={"items":[{"type":"module","title":"Ethex","doc":"Documentation for `Ethex`.","ref":"Ethex.html"},{"type":"function","title":"Ethex.block_number/1","doc":"","ref":"Ethex.html#block_number/1"},{"type":"function","title":"Ethex.create_wallet/0","doc":"","ref":"Ethex.html#create_wallet/0"},{"type":"function","title":"Ethex.create_wallet/1","doc":"","ref":"Ethex.html#create_wallet/1"},{"type":"module","title":"Ethex.Abi","doc":"Parse `xxx.abi.json`","ref":"Ethex.Abi.html"},{"type":"module","title":"Ethex.Utils","doc":"Utils","ref":"Ethex.Utils.html"},{"type":"function","title":"Ethex.Utils.from_hex/1","doc":"From hex","ref":"Ethex.Utils.html#from_hex/1"},{"type":"function","title":"Example - Ethex.Utils.from_hex/1","doc":"iex> Ethex.Utils.from_hex \"0x2766\"\n  10086","ref":"Ethex.Utils.html#from_hex/1-example"},{"type":"function","title":"Ethex.Utils.from_wei/2","doc":"Convert wei to eth.","ref":"Ethex.Utils.html#from_wei/2"},{"type":"function","title":"Example - Ethex.Utils.from_wei/2","doc":"iex> Ethex.Utils.from_wei(4011000000000000, 18)\n  0.004011","ref":"Ethex.Utils.html#from_wei/2-example"},{"type":"function","title":"Ethex.Utils.to_hex/1","doc":"To hex","ref":"Ethex.Utils.html#to_hex/1"},{"type":"function","title":"Example - Ethex.Utils.to_hex/1","doc":"iex> Ethex.Utils.to_hex 10086\n  \"0x2766\"","ref":"Ethex.Utils.html#to_hex/1-example"},{"type":"function","title":"Ethex.Utils.to_wei/2","doc":"Convert eth to wei.","ref":"Ethex.Utils.html#to_wei/2"},{"type":"function","title":"Example - Ethex.Utils.to_wei/2","doc":"iex> Ethex.Utils.to_wei(0.1, 18)\n  100000000000000000","ref":"Ethex.Utils.html#to_wei/2-example"},{"type":"module","title":"Ethex.Web3.JsonRpc","doc":"","ref":"Ethex.Web3.JsonRpc.html"},{"type":"module","title":"Gossip Method - Ethex.Web3.JsonRpc","doc":"These methods track the head of the chain.\nThis is how transactions make their way around the network,\nfind their way into blocks, and how clients find out about new blocks.","ref":"Ethex.Web3.JsonRpc.html#module-gossip-method"},{"type":"module","title":"History Method - Ethex.Web3.JsonRpc","doc":"Fetches historical records of every block back to genesis.\nThis is like one large append-only file, and includes all block headers,\nblock bodies, uncle blocks, and transaction receipts.","ref":"Ethex.Web3.JsonRpc.html#module-history-method"},{"type":"module","title":"State Method - Ethex.Web3.JsonRpc","doc":"Methods that report the current state of all the data stored.\nThe \"state\" is like one big shared piece of RAM,\nand includes account balances, contract data, and gas estimations.","ref":"Ethex.Web3.JsonRpc.html#module-state-method"},{"type":"function","title":"Ethex.Web3.JsonRpc.eth_block_number/1","doc":"Returns the number of most recent block.","ref":"Ethex.Web3.JsonRpc.html#eth_block_number/1"},{"type":"function","title":"Ethex.Web3.JsonRpc.eth_call/3","doc":"Executes a new message call immediately without creating a transaction on the block chain.","ref":"Ethex.Web3.JsonRpc.html#eth_call/3"},{"type":"function","title":"Parameters - Ethex.Web3.JsonRpc.eth_call/3","doc":"1. Object - The transaction call object\n\n- from: DATA, 20 Bytes - (optional) The address the transaction is sent from.\n- to: DATA, 20 Bytes - The address the transaction is directed to.\n- gas: QUANTITY - (optional) Integer of the gas provided for the transaction execution.\n    eth_call consumes zero gas, but this parameter may be needed by some executions.\n- gasPrice: QUANTITY - (optional) Integer of the gasPrice used for each paid gas\n- value: QUANTITY - (optional) Integer of the value sent with this transaction\n- data: DATA - (optional) Hash of the method signature and encoded parameters.\n    For details see Ethereum Contract ABI in the Solidity documentation\n\n2. QUANTITY | TAG - integer block number,\n    or the string \"latest\", \"earliest\" or \"pending\",\n    see the default block parameter","ref":"Ethex.Web3.JsonRpc.html#eth_call/3-parameters"},{"type":"function","title":"Ethex.Web3.JsonRpc.eth_estimate_gas/2","doc":"Generates and returns an estimate of how much gas is necessary to allow the\ntransaction to complete. The transaction will not be added to the blockchain.\nNote that the estimate may be significantly more than the amount of gas actually\nused by the transaction, for a variety of reasons including EVM mechanics and node performance.","ref":"Ethex.Web3.JsonRpc.html#eth_estimate_gas/2"},{"type":"function","title":"Ethex.Web3.JsonRpc.eth_get_filter_changes/2","doc":"Polling method for a filter, which returns an array of logs which occurred since last poll.\n\nREFERENCE: https://ethereum.stackexchange.com/questions/41129/web3-eth-getfilterchangesweb3-filter-filter-id-throws-filter-not-found","ref":"Ethex.Web3.JsonRpc.html#eth_get_filter_changes/2"},{"type":"function","title":"Ethex.Web3.JsonRpc.eth_get_filter_logs/2","doc":"使用 filter_id 获取自 from 以来的 logs","ref":"Ethex.Web3.JsonRpc.html#eth_get_filter_logs/2"},{"type":"function","title":"Ethex.Web3.JsonRpc.eth_get_logs/2","doc":"Returns an array of all logs matching a given filter object.","ref":"Ethex.Web3.JsonRpc.html#eth_get_logs/2"},{"type":"function","title":"Ethex.Web3.JsonRpc.eth_get_transaction_count/3","doc":"Returns the number of transactions sent from an address.","ref":"Ethex.Web3.JsonRpc.html#eth_get_transaction_count/3"},{"type":"function","title":"Ethex.Web3.JsonRpc.eth_new_filter/2","doc":"Creates a filter object, based on filter options,\nto notify when the state changes (logs).\nTo check if the state has changed, call eth_getFilterChanges.\n\n%{\n  address: [\"0x4aF359FC3dd065F185739EC2f8F444A746A912f2\"],\n  fromBlock: \"0x16DF136\",\n  toBlock: \"latest\"\n}","ref":"Ethex.Web3.JsonRpc.html#eth_new_filter/2"},{"type":"function","title":"Ethex.Web3.JsonRpc.eth_send_raw_transaction/2","doc":"Creates new message call transaction or\na contract creation for signed transactions.","ref":"Ethex.Web3.JsonRpc.html#eth_send_raw_transaction/2"},{"type":"module","title":"Ethex.Web3.Structs.BlockRange","doc":"","ref":"Ethex.Web3.Structs.BlockRange.html"},{"type":"type","title":"Ethex.Web3.Structs.BlockRange.t/0","doc":"","ref":"Ethex.Web3.Structs.BlockRange.html#t:t/0"},{"type":"module","title":"Ethex.Web3.Structs.Event","doc":"","ref":"Ethex.Web3.Structs.Event.html"},{"type":"type","title":"Ethex.Web3.Structs.Event.t/0","doc":"","ref":"Ethex.Web3.Structs.Event.html#t:t/0"},{"type":"module","title":"Ethex.Web3.Wallet","doc":"Wallet","ref":"Ethex.Web3.Wallet.html"},{"type":"function","title":"Ethex.Web3.Wallet.create/1","doc":"","ref":"Ethex.Web3.Wallet.html#create/1"},{"type":"function","title":"Ethex.Web3.Wallet.get_private_key/0","doc":"","ref":"Ethex.Web3.Wallet.html#get_private_key/0"},{"type":"extras","title":"Ethex","doc":"# Ethex\n\nEthereum Contract interaction via json-rpc for multi-chain based on ex_abi, focused on Smart Contract interaction, with reading contract, writing contract, synchronizing contract events.\n\n**NOTE: version `1.x.x` is incompatible with `0.x.x`**","ref":"readme.html"},{"type":"extras","title":"Installation - Ethex","doc":"The package can be installed by adding `ethex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ethex, \"~> 1.0.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Ethex","doc":"You can get eth_block_number directly:\n\n```elixir\niex(1)> Ethex.block_number \"https://binance.llamarpc.com\"\n{:ok, 46792582}\n```","ref":"readme.html#usage"},{"type":"extras","title":"Interact with contract - Ethex","doc":"First write a module to parse abi, known which contract address interact with and rpc endpoint request to.\n\n```elixir\ndefmodule Test.USDT do\n  @moduledoc false\n  use Ethex.Abi,\n    rpc: \"https://binance.llamarpc.com\",\n    abi_path: \"./priv/abi/usdt.abi.json\",\n    contract_address: \"0x55d398326f99059fF775485246999027B3197955\"\nend\n```\n\n**Read the Contract**\n\n```elixir\niex(1)> Test.USDT.symbol\n{:ok, \"USDT\"}\n\niex(3)> Test.USDT.name\n{:ok, \"Tether USD\"}\n\niex(5)> Test.USDT.decimals\n{:ok, 18}\n\niex(7)> Test.USDT.get_owner\n{:ok, \"0xf68a4b64162906eff0ff6ae34e2bb1cd42fef62d\"}\n\niex(9)> Test.USDT.balance_of \"0x8CcF629e123D83112423c283998443829A291334\"\n{:ok, 4011000000000000}\n```\n\n**Get logs and decode**\n\nBy invoking `eth_getLogs` method, it can fetch contract logs from chain with block range.\nThen, decode logs to events as result.\n\n```elixir\niex(1)> block_range = %Ethex.Web3.Structs.BlockRange{from_block: 46798863, to_block: 46798863}\n\niex(2)> {:ok, logs} = Test.USDT.get_logs_and_decode block_range\n{:ok,\n [\n   %Ethex.Web3.Structs.Event{\n     address: \"0x55d398326f99059ff775485246999027b3197955\",\n     block_hash: \"0x943b3daa9119d8d4314f816a0f00cd824c9fe73a6d1a3076d16fe1ce91fc173d\",\n     block_number: 46798863,\n     block_timestamp: 1739978103,\n     log_index: \"0x1c\",\n     removed: false,\n     transaction_hash: \"0x2c3795501857b8d6e1ccd00b4132373b25b76ccd399f1719aadbfec8d688c238\",\n     transaction_index: \"0x6\",\n     returns: [\n       %{\"from\" => \"0x47a90a2d92a8367a91efa1906bfc8c1e05bf10c4\"},\n       %{\"to\" => \"0x2d3b5ca3e5ff50b12cd9d58216abaaa6b3836443\"},\n       %{\"value\" => 296241844581231922050}\n     ],\n     event_name: \"Transfer\"\n   },\n   ...\n ]\n```\n\nFor polling logs, you need to maintaining block range to avoid `excceed max block` error. \n\nSo here is a util for generating block range, it need `latest` or the block number you sync last time. \nThe reason why not use `eth_getFilterChanges` is that some chain not implement this method.\n\nNOTE: the max block range in Polygon is 1000, in BSC is 5000.\n\n```elixir\niex(6)> Test.USDT.gen_block_range \"latest\"\n{:ok, 46799328,\n %Ethex.Web3.Structs.BlockRange{from_block: 46799308, to_block: 46799328}}\n \niex(7)> Test.USDT.gen_block_range 46798000\n{:ok, 46798800,\n %Ethex.Web3.Structs.BlockRange{from_block: 46798000, to_block: 46798800}}\n```\n\nIf wanna sync logs automatically, using GenServer with loop, and maintaining block range. Here is an example,\n\n```elixir\ndefmodule Test.USDT do\n  @moduledoc false\n  use GenServer\n\n  use Ethex.Abi,\n    # rpc: \"https://data-seed-prebsc-1-s1.bnbchain.org:8545\",\n    rpc: \"https://binance.llamarpc.com\",\n    abi_path: \"./priv/abi/usdt.abi.json\",\n    contract_address: \"0x55d398326f99059fF775485246999027B3197955\"\n\n  @loop_interval 10\n\n  def start_link(_) do\n    GenServer.start_link(__MODULE__, :ok, name: __MODULE__)\n  end\n\n  @impl true\n  def init(:ok) do\n    Process.send_after(self(), :loop, :timer.seconds(@loop_interval))\n    {:ok, %{last_sync_block: \"latest\"}}\n  end\n\n  @impl true\n  def handle_info(:loop, %{last_sync_block: last_sync_block} = _state) do\n    {:ok, cur_sync_block, block_range} = gen_block_range(last_sync_block)\n    {:ok, _evts} = get_logs_and_decode(block_range)\n\n    # do some other work, such as save events into database\n    # Repo.insert evts\n\n    Process.send_after(self(), :loop, :timer.seconds(@loop_interval))\n    {:noreply, %{last_sync_block: cur_sync_block}}\n  end\nend\n```","ref":"readme.html#interact-with-contract"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.1"}}